VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Public Types | Public Member Functions | List of all members
IDataBrowserDelegate Class Referenceabstract

DataBrowser Interface. More...

`#include <idatabrowserdelegate.h>`

Inheritance diagram for IDataBrowserDelegate:

## Public Types
enum | Flags { kRowSelected = 1 << 1 }

## Public Member Functions
virtual | ~IDataBrowserDelegate () noexcept=default
Setup
virtual int32_t | dbGetNumRows (CDataBrowser *browser)=0
| return number of rows for CDataBrowser browser More...
virtual int32_t | dbGetNumColumns (CDataBrowser *browser)=0
| return number of columns for CDataBrowser browser More...
virtual bool | dbGetColumnDescription (int32_t index, CCoord &minWidth, CCoord &maxWidth, CDataBrowser *browser)=0
virtual CCoord | dbGetCurrentColumnWidth (int32_t index, CDataBrowser *browser)=0
| return current width of index column More...
virtual void | dbSetCurrentColumnWidth (int32_t index, const CCoord &width, CDataBrowser *browser)=0
| the width of a column has changed More...
virtual CCoord | dbGetRowHeight (CDataBrowser *browser)=0
| return height of one row More...
virtual CCoord | dbGetHeaderHeight (CDataBrowser *browser)=0
| return height of header More...
virtual bool | dbGetLineWidthAndColor (CCoord &width, CColor &color, CDataBrowser *browser)=0
| return the line width and color More...
virtual void | dbAttached (CDataBrowser *browser)=0
| databrowser view was attached to a parent More...
virtual void | dbRemoved (CDataBrowser *browser)=0
| databrowser view will be removed from its parent More...
Drawing
virtual void | dbDrawHeader (CDrawContext *context, const CRect &size, int32_t column, int32_t flags, CDataBrowser *browser)=0
| draw the db header More...
virtual void | dbDrawCell (CDrawContext *context, const CRect &size, int32_t row, int32_t column, int32_t flags, CDataBrowser *browser)=0
| draw a db cell More...
Mouse Handling
virtual CMouseEventResult | dbOnMouseDown (const CPoint &where, const CButtonState &buttons, int32_t row, int32_t column, CDataBrowser *browser)=0
| mouse button was pressed on a cell More...
virtual CMouseEventResult | dbOnMouseMoved (const CPoint &where, const CButtonState &buttons, int32_t row, int32_t column, CDataBrowser *browser)=0
| mouse was moved over a cell More...
virtual CMouseEventResult | dbOnMouseUp (const CPoint &where, const CButtonState &buttons, int32_t row, int32_t column, CDataBrowser *browser)=0
| mouse button was released on a cell More...
Drag'n Drop Handling
virtual void | dbOnDragEnterBrowser (IDataPackage *drag, CDataBrowser *browser)=0
virtual void | dbOnDragExitBrowser (IDataPackage *drag, CDataBrowser *browser)=0
virtual DragOperation | dbOnDragEnterCell (int32_t row, int32_t column, const CPoint &where, IDataPackage *drag, CDataBrowser *browser)=0
virtual DragOperation | dbOnDragMoveInCell (int32_t row, int32_t column, const CPoint &where, IDataPackage *drag, CDataBrowser *browser)=0
virtual void | dbOnDragExitCell (int32_t row, int32_t column, IDataPackage *drag, CDataBrowser *browser)=0
virtual bool | dbOnDropInCell (int32_t row, int32_t column, const CPoint &where, IDataPackage *drag, CDataBrowser *browser)=0
Selection <br>
virtual void | dbSelectionChanged (CDataBrowser *browser)=0
| the selection of the db changed More...
Cell Text Editing
virtual void | dbCellTextChanged (int32_t row, int32_t column, UTF8StringPtr newText, CDataBrowser *browser)=0
| the text of the cell changed beginTextEdit was called for More...
virtual void | dbCellSetupTextEdit (int32_t row, int32_t column, CTextEdit *textEditControl, CDataBrowser *browser)=0
| beginTextEdit calls this, so you can setup the textedit control More...
Keyboard Handling
virtual void | dbOnKeyboardEvent (KeyboardEvent &event, CDataBrowser *browser)=0

## Detailed Description

DataBrowser Interface.

## Member Enumeration Documentation

## ◆ Flags

enum Flags

Enumerator
kRowSelected |

## Constructor & Destructor Documentation

## ◆ ~IDataBrowserDelegate()

virtual ~IDataBrowserDelegate | ( |  | ) |
| virtual default noexcept

## Member Function Documentation

## ◆ dbAttached()

virtual void dbAttached | ( | CDataBrowser * | browser | ) |
| pure virtual

databrowser view was attached to a parent

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbCellSetupTextEdit()

virtual void dbCellSetupTextEdit | ( | int32_t | row,
|  | int32_t | column,
|  | CTextEdit * | textEditControl,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

beginTextEdit calls this, so you can setup the textedit control

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbCellTextChanged()

virtual void dbCellTextChanged | ( | int32_t | row,
|  | int32_t | column,
|  | UTF8StringPtr | newText,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

the text of the cell changed beginTextEdit was called for

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbDrawCell()

virtual void dbDrawCell | ( | CDrawContext * | context,
|  | const CRect & | size,
|  | int32_t | row,
|  | int32_t | column,
|  | int32_t | flags,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

draw a db cell

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbDrawHeader()

virtual void dbDrawHeader | ( | CDrawContext * | context,
|  | const CRect & | size,
|  | int32_t | column,
|  | int32_t | flags,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

draw the db header

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbGetColumnDescription()

virtual bool dbGetColumnDescription | ( | int32_t | index,
|  | CCoord & | minWidth,
|  | CCoord & | maxWidth,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbGetCurrentColumnWidth()

virtual CCoord dbGetCurrentColumnWidth | ( | int32_t | index,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

return current width of index column

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbGetHeaderHeight()

virtual CCoord dbGetHeaderHeight | ( | CDataBrowser * | browser | ) |
| pure virtual

return height of header

Implemented in DataBrowserDelegateAdapter.

## ◆ dbGetLineWidthAndColor()

virtual bool dbGetLineWidthAndColor | ( | CCoord & | width,
|  | CColor & | color,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

return the line width and color

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbGetNumColumns()

virtual int32_t dbGetNumColumns | ( | CDataBrowser * | browser | ) |
| pure virtual

return number of columns for CDataBrowser browser

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbGetNumRows()

virtual int32_t dbGetNumRows | ( | CDataBrowser * | browser | ) |
| pure virtual

return number of rows for CDataBrowser browser

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbGetRowHeight()

virtual CCoord dbGetRowHeight | ( | CDataBrowser * | browser | ) |
| pure virtual

return height of one row

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbOnDragEnterBrowser()

virtual void dbOnDragEnterBrowser | ( | IDataPackage * | drag,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in DataBrowserDelegateAdapter.

## ◆ dbOnDragEnterCell()

virtual DragOperation dbOnDragEnterCell | ( | int32_t | row,
|  | int32_t | column,
|  | const CPoint & | where,
|  | IDataPackage * | drag,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in DataBrowserDelegateAdapter.

## ◆ dbOnDragExitBrowser()

virtual void dbOnDragExitBrowser | ( | IDataPackage * | drag,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in DataBrowserDelegateAdapter.

## ◆ dbOnDragExitCell()

virtual void dbOnDragExitCell | ( | int32_t | row,
|  | int32_t | column,
|  | IDataPackage * | drag,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in DataBrowserDelegateAdapter.

## ◆ dbOnDragMoveInCell()

virtual DragOperation dbOnDragMoveInCell | ( | int32_t | row,
|  | int32_t | column,
|  | const CPoint & | where,
|  | IDataPackage * | drag,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in DataBrowserDelegateAdapter.

## ◆ dbOnDropInCell()

virtual bool dbOnDropInCell | ( | int32_t | row,
|  | int32_t | column,
|  | const CPoint & | where,
|  | IDataPackage * | drag,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in DataBrowserDelegateAdapter.

## ◆ dbOnKeyboardEvent()

virtual void dbOnKeyboardEvent | ( | KeyboardEvent & | event,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbOnMouseDown()

virtual CMouseEventResult dbOnMouseDown | ( | const CPoint & | where,
|  | const CButtonState & | buttons,
|  | int32_t | row,
|  | int32_t | column,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

mouse button was pressed on a cell

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbOnMouseMoved()

virtual CMouseEventResult dbOnMouseMoved | ( | const CPoint & | where,
|  | const CButtonState & | buttons,
|  | int32_t | row,
|  | int32_t | column,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

mouse was moved over a cell

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbOnMouseUp()

virtual CMouseEventResult dbOnMouseUp | ( | const CPoint & | where,
|  | const CButtonState & | buttons,
|  | int32_t | row,
|  | int32_t | column,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

mouse button was released on a cell

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbRemoved()

virtual void dbRemoved | ( | CDataBrowser * | browser | ) |
| pure virtual

databrowser view will be removed from its parent

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbSelectionChanged()

virtual void dbSelectionChanged | ( | CDataBrowser * | browser | ) |
| pure virtual

the selection of the db changed

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

## ◆ dbSetCurrentColumnWidth()

virtual void dbSetCurrentColumnWidth | ( | int32_t | index,
|  | const CCoord & | width,
|  | CDataBrowser * | browser
| ) |  |
| pure virtual

the width of a column has changed

Implemented in GenericStringListDataBrowserSource, and DataBrowserDelegateAdapter.

The documentation for this class was generated from the following file:

- idatabrowserdelegate.h